function read_files_tb_norm_controls

global GeneIdNormControl n_s n_r red_controls green_controls signal_controls reference_controls ColumnNormControl MetaColumnNormControl RowNormControl MetaRowNormControl n_s n_r bkg_signal_controls bkg_reference_controls

for s=1:n_s;                                                        % for each sample,
    for r=1:n_r;                                            % for each replicate,
        file=[int2str(s) '_' int2str(r) '_norm_controls.txt'];       % for filename,   
        [Sig_controls(s,r).Flag...
         Sig_controls(s,r).SignMed...
         Sig_controls(s,r).BackMed... 
         Ref_controls(s,r).Flag... 
         Ref_controls(s,r).SignMed...
         Ref_controls(s,r).BackMed]...
        = textread(file,'%d %f %f %d %f %f');  % load the data into a structure.
    end;
end;

n_c=length(Sig_controls(1,1).SignMed);

% Read spot-coordinates into Matlab:
[MetaRowNormControl MetaColumnNormControl RowNormControl ColumnNormControl] = textread('Gene_coordenates_norm_controls.txt','%f %f %f %f');

% Read Gene Id information into Matlab:
[GeneIdNormControl]= textread ('Gene_Id_Norm_Control.txt','%s','delimiter','\n');

%%%%%%%%%%%%%%%%   remove those controls that are saturated   %%%%%%%%%%%%%%%%%%%%%%%

[GeneIdNormControl]= GeneIdNormControl;
Gene_IdNormControl= char(GeneIdNormControl);
index=zeros(n_c,1);
sat=0;
index2=zeros(n_c,1);
a=60000;

for s=1:n_s,
    for r=1:n_r,
        for i=1:n_c,
            if(index2(i)==0),
                b=Sig_controls(s,r).SignMed(i);
                c=Ref_controls(s,r).SignMed(i);
                if (b>=a) | (c>=a),
                    sat=sat+1;
                    index(sat)=i;
                    index2(i)=1;
                end;
            end;
        end;
    end;
end;

index=sort(index(1:sat,1));

for i=1:sat,    
    for s=1:n_s,
        for r=1:n_r,
            Sig_controls(s,r).Flag(index(i))=NaN;
            Ref_controls(s,r).Flag(index(i))=NaN;
            Sig_controls(s,r).SignMed(index(i))=NaN;
            Ref_controls(s,r).SignMed(index(i))=NaN;
            Sig_controls(s,r).BackMed(index(i))=NaN;
            Ref_controls(s,r).BackMed(index(i))=NaN;
            
            Gene_IdNormControl(index(i))=[];
        end;
    end;
    
end;

n_a=n_r*n_s;
signal_controls = ones(n_c-sat,n_a);
reference_controls = ones(n_c-sat,n_a);
bkg_signal_controls = ones(n_c-sat,n_a);
bkg_reference_controls = ones(n_c-sat,n_a);

j=0;
for i=1:n_c,
    if index2(i)==0, 
        j=j+1;
        for s=1:n_s,
            for r=1:n_r,
                index = r + n_r*(s-1); % index for columns in matrix densities.
                signal_controls(j,index) = Sig_controls(s,r).SignMed(i);
                reference_controls(j,index) = Ref_controls(s,r).SignMed(i);
                bkg_signal_controls(j,index)= Sig_controls(s,r).BackMed(i);
                bkg_reference_controls(j,index)= Ref_controls(s,r).BackMed(i);  
            end;
        end;
    end;
end;

for s=1:n_s
        if (s==1)|(s==2)|(s==4)
        for r=1:3
            green_controls(:,4*(s-1)+r)=signal_controls(:,4*(s-1)+r);
            red_controls(:,4*(s-1)+r)=reference_controls(:,4*(s-1)+r);
        end
        green_controls(:,4*(s-1)+4)=reference_controls(:,4*(s-1)+4);
        red_controls(:,4*(s-1)+4)=signal_controls(:,4*(s-1)+4);
    elseif (s==3)
        for r=1:2
            green_controls(:,4*(s-1)+r)=signal_controls(:,4*(s-1)+r);
            red_controls(:,4*(s-1)+r)=reference_controls(:,4*(s-1)+r);
        end
        green_controls(:,4*(s-1)+3)=reference_controls(:,4*(s-1)+3);
        red_controls(:,4*(s-1)+3)=signal_controls(:,4*(s-1)+3);
        green_controls(:,4*(s-1)+4)=signal_controls(:,4*(s-1)+4);
        red_controls(:,4*(s-1)+4)=reference_controls(:,4*(s-1)+4);
    end;
end;